//
// Generated by JTB 1.3.2
//

package visitor;
import syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
enum iType { setInst, jumpInst, callInst } 
class Inst {
        public int instNo;
        public int freq;
        public HashSet<Pseudo> livePseudos;
        public HashSet<Reg> liveRegs;
        public HashSet<Pseudo> req;
        public HashSet<Reg> HRreq;
        public Pseudo def;
        public Reg defHardReg;
        public HashSet<Inst> pred;
        public iType instType;
        public Inst(){
                instNo = -1;
                freq = 0;
                instType = iType.setInst;
                livePseudos = new HashSet<Pseudo>();
                liveRegs = new HashSet<Reg>();
                req = new HashSet<Pseudo>();
                HRreq = new HashSet<Reg>();
                pred = new HashSet<Inst>();
        }
        public String toString(){
                return ("Instno = " + instNo);
        }

}
class InstComp implements Comparator<Inst>{
        public int compare(Inst i1, Inst i2){
                if ( i1.instNo < i2.instNo)
                        return -1;
                if ( i1.instNo == i2.instNo)
                        return 0;
                return 1;
        }
        public boolean equals(Object incmp){
                return false;
                
        }
        
}
class Interval{
         Inst start;
         Inst end;
         Pseudo ps;
         public String toString(){
                 return "Start = "+start+" End " +end;
         }
//         Inst spPoint;
}
class Pseudo{
        public int pseudoNo;
        boolean local;
        public Pseudo basePseudo;
        public Reg baseReg;
        public Loc location;

        Interval  lInt;
        public String toString(){
                return ("psNo = " + pseudoNo +
                           "location" + location +
                           "lInt " + lInt);
        }
}

class Reg{
        public int regNo;
        boolean callerSave;
        boolean precolored;
        public String toString(){
                return ("Reg = " + regNo);
        }
        public Reg(){
                regNo = -1;
                callerSave = false;
                precolored = false;
        }
}

class Loc{
        public int locNo;
        public String toString(){
                return ("loc = " + locNo);
        }
}
public class CollectInput<R,A> implements GJVisitor<R,A> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   Inst [] instructions;
   Reg [] registers;
   Pseudo [] pseudos;
   Loc [] locations;
   int nInsts;
   int nPseudos;
   int nRegs;
   int nLSMPseudos;

   boolean freeRegs[];
   int globalLoc;
   Reg [] spLoadReg ;
   Reg spStoreReg ;

   Hashtable<Interval,Reg> IsR;
//   Hashtable<Interval,Loc> IsL;

   boolean build_sets;
   int preColCnt;

   public CollectInput (){
           nInsts = nPseudos = nRegs = nLSMPseudos = 0;
           IsR = new Hashtable<Interval,Reg>();
           //IsL = new Hashtable<Interval,Loc>();
           build_sets = false;
           preColCnt = 0;
   }
   int strToInt(String s){
           return (new Integer(s)).intValue();
   }
   int intTokenToInt(NodeToken n){
           return (new Integer(n.toString())).intValue();
   }
   void myassert(boolean cond, String msg){
           if (!cond){
                   new Exception(msg).printStackTrace();
                   System.exit(-1);
           }
                   
           
   }

   public R visit(NodeList n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeListOptional n, A argu) {
      if ( n.present() ) {
         R _ret=null;
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this,argu);
            _count++;
         }
         return _ret;
      }
      else
         return null;
   }

   public R visit(NodeOptional n, A argu) {
      if ( n.present() )
         return n.node.accept(this,argu);
      else
         return null;
   }

   public R visit(NodeSequence n, A argu) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeToken n, A argu) { return null; }

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> scalarParams()
    * f1 -> setCollection()
    * f2 -> paramCollection()
    * f3 -> <EOF>
    */
   public R visit(Goal n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);

      instructions = new Inst[nInsts];
      // +1 because there is hole in register file.
      registers = new Reg[nRegs+1];
      // +1 because pseudos start from 1.
      pseudos = new Pseudo[nPseudos+1];
      locations = new Loc[nLSMPseudos+1];
      freeRegs = new boolean[nRegs+1];

      n.f1.accept(this, argu);
      n.f2.accept(this, argu);


      spLoadReg = new Reg[2];
      spLoadReg[0] = registers[4];
      spLoadReg[1] = registers[5];
      freeRegs[4] = false;
      freeRegs[5] = false;

      spStoreReg = new Reg();
      spStoreReg = registers[5];
      globalLoc = 1; // locations start from 1 not zero.

      
      doLinearScan();
      return _ret;
   }
   void makeLinearInterval(Pseudo p){
           boolean lbfound = false; // lower bound found.
           Inst lastInst = null;

           p.lInt = new Interval();
           for (int i=0;i< nInsts;++i){
                   Inst inst = instructions[i];
                   if (inst.def == p || 
                                   inst.livePseudos.contains(p)){
                        if (!lbfound){
                                p.lInt.start = inst;
                                lbfound = true;
                         } else {
                           lastInst = inst;
                        }
                   }
           }
           if (p.lInt.start != null){
                   p.lInt.end = lastInst;
           }
           p.lInt.ps = p;
                   
   }
   void makeLinearIntervals(){
           for(int i=1;i<=nPseudos;++i)
                   if (pseudos[i] != null)
                           makeLinearInterval(pseudos[i]);
   }

   void expireOld(Vector<Interval> active, Interval lint){
           Enumeration<Interval> activeEl=active.elements();
           while (activeEl.hasMoreElements()){
           
                   Interval li = (Interval)activeEl.nextElement();
                   // In the algorithm of the paper we see that this
                   // thingi is sorted and hence they can stop after one
                   // failed if condition. But here I am not. So I will
                   // not return but rather visit all the elements.
                   if (li.end.instNo < lint.start.instNo){
                           active.remove(li);
                           makeRegFree(li);
                   } 
                   
           }
           
   }
   Interval spillAtInterval(Vector <Interval> active, Interval lInt){

           Interval li = active.lastElement();

           // Find the interval with farthest end point.
           // We ensure that active is sorted in increasing end point.

           if (li.end.instNo > lInt.end.instNo){
                   IsR.put(lInt, (Reg)IsR.get(li));
                   IsR.remove(li);
                   li.ps.location = nextLoc();
                   active.remove(li);
                   addToActive(active,lInt);
                   return li;
           } else {
                   lInt.ps.location = nextLoc();
                   return lInt;
           }
   }
   void addToActive(Vector<Interval> active, Interval lInt){
           Enumeration<Interval> activeEl=active.elements();
           int indx = 0;
           while(activeEl.hasMoreElements()){
                   Interval li = (Interval)activeEl.nextElement();
                   if (li.end.instNo > lInt.end.instNo)
                           break;
                   indx ++;
           }
           active.add(indx,lInt);
   }
   Reg getFreeReg(){
           
           for (int i=0;i<=nRegs;++i){
                   if (freeRegs[i] ){
                           if (registers[i].precolored)
                                   continue;
                           freeRegs[i] = false;
                           return registers[i];
                   }
           }
           return null;
           
   }
   int avail_registers(){
           return (nRegs - preColCnt - 2); // -2 because we take two
                                           // registers out for loading and storing.
   }
   void makeRegFree(Interval li){
          Reg reg = (Reg)IsR.get(li);
          for (int i=0;i<=nRegs;++i)
                  if (registers[i] == reg) {
                          myassert(freeRegs[i] == false,
                                   "Trying to free a reg that is already free");
                          freeRegs[i] = true;
                  }
   }
   Loc nextLoc(){
           return locations[globalLoc++];
           
   }
   void colorThePrecolored(){
           int i;
           for (i=0;i<=nRegs;++i){
                   if (freeRegs[i])
                           if (registers[i].precolored)
                                   preColCnt++;
           }
   }
   
   void addToSortedIntervals(Vector<Interval> sp, Interval li){
           
           int i;
           for (i=0;i<sp.size();++i){
                   Interval cur_li = sp.elementAt(i);
                   if (cur_li.start.instNo > li.start.instNo)
                           break;
           }
           sp.add(i,li);
          
   }
   void linearScanRegisterAllocation(){

           colorThePrecolored();
           Vector<Interval> sp = new Vector<Interval>(); // startpoints
           int i;
           for (i=1;i<=nPseudos;++i){
                   addToSortedIntervals(sp, pseudos[i].lInt);
           }
                
           Vector<Interval> active = new Vector<Interval>();

           for (i=0;i<sp.size();++i){
                
                   Pseudo ps = sp.elementAt(i).ps;
                   expireOld(active, ps.lInt);

                   if  (active.size() >= avail_registers()) {
                           Interval tInt = spillAtInterval(active,ps.lInt);
//                           tInt.spPoint = inst;
                   } else {
                           IsR.put(ps.lInt, getFreeReg());
                           addToActive(active,ps.lInt);
                   }
           }
   }
   void output_psr(){
           System.out.println("PsR:=");
           for (int instNo=0;instNo < nInsts ; ++instNo){
                Iterator<Pseudo> itr = instructions[instNo].req.iterator();
                int j = 0;
                while (itr.hasNext()){
                        Pseudo p = (Pseudo)itr.next();

                        Interval lInt = p.lInt;


                        Reg reg = IsR.get(lInt);
                        
                        if (reg == null){
                                System.out.println(instNo+" "+
                                                   p.pseudoNo+" "+
                                                   spLoadReg[j++].regNo);
                        
                        }
                }
                itr = instructions[instNo].livePseudos.iterator();
                
                while (itr.hasNext()){
                        Pseudo p = (Pseudo)itr.next();

                        Interval lInt = p.lInt;


                        Reg reg = IsR.get(lInt);
 

                        if (reg != null){
                                System.out.println(instNo+" "+
                                                   p.pseudoNo+" "+
                                                   reg.regNo);
                        }
                        
                }
           }
           System.out.println(";");
           
   }
   void output_xdef(){
           System.out.println("xdef:=");
           for (int instNo=0;instNo < nInsts ; ++instNo){
                {
                        Pseudo p = instructions[instNo].def;

                        if (p == null)
                                continue;
                        Interval lInt = p.lInt;

                        Reg reg = IsR.get(lInt);
                        if (reg != null){

                                System.out.println(instNo+" "+
                                                   p.pseudoNo+" "+
                                                   reg.regNo);
                        } else {
                                System.out.println(instNo+" "+
                                                   p.pseudoNo+" "+
                                                   spStoreReg.regNo);
                        }
                }
           }
           System.out.println(";");
           
   }
   void output_spLoad(){
           // for each instruction inst do
                // for each pseudo p that is used here
                // lInt = liveInterval of p
                // if inst is Not between [lInt.start, lInt.spPoint)
                // the output spLoad

                // if inst is a call instruction then
                // for each pseudo that has a callerSave register
                // assigned, do spLoad after call instruction.
           System.out.println("spLoad:=");
           for (int instNo=0;instNo < nInsts ; ++instNo){
                Inst inst = instructions[instNo];
                Iterator<Pseudo> itr = inst.req.iterator();
                int j = 0;
                while (itr.hasNext()){
                        Pseudo p = (Pseudo)itr.next();

                        Interval lInt = p.lInt;

                        Reg reg = IsR.get(lInt);
                        if (reg != null){
                               // do nothing. 
                        } else {
                                myassert(p.location != null,
                                        p.toString()+" Must have a location");
                                System.out.println(instNo+" "+
                                                   p.pseudoNo+" "+
                                                   spLoadReg[j++].regNo);
                        
                        }
                }
                if (inst.instType == iType.callInst){
                        itr = inst.livePseudos.iterator();
                        while (itr.hasNext()){
                                
                                // We want to insert the load before the
                                // dummy instruction.

                                Pseudo p = (Pseudo)itr.next();
                                Interval lInt = p.lInt;

                                if (inst.instNo % 2 == 0)
                                        continue;

                                Reg reg = IsR.get(lInt);
                                if (reg != null){
                                        if (reg.callerSave){

                                                System.out.println(instNo+" "+
                                                                   p.pseudoNo+" "+
                                                                   reg.regNo);
                                                if (p.location == null)
                                                        p.location = nextLoc();
                                                
                                        }
                                }
                        }
                }
           }
           System.out.println(";");
           
   }
   void output_spStore(){
            // for each instruction inst do
                // for each pseudo p that is defined here
                // lInt = liveInterval of p
                // if inst is Not between [lInt.start, lInt.spPoint)
                // the output spStore

                // if inst is a call instruction then
                // for each pseudo that has a callerSave register
                // assigned, do spStore before call instruction.
           
           System.out.println("spStore:=");
           for (int instNo=0;instNo <  nInsts ; ++instNo){
                Pseudo p = (Pseudo)instructions[instNo].def;
                Interval lInt;
                Reg reg;

                if (p != null){
                      
                        lInt = p.lInt;

                        reg = IsR.get(lInt);
                        if (reg != null){
                               // do nothing. 
                        } else {
                                System.out.println(instNo+" "+
                                                   p.pseudoNo+" "+
                                                   spStoreReg.regNo);
                        
                        }
                }
                if (instructions[instNo].instType == iType.callInst){

                        if (instNo % 2 == 1)
                                continue;
                        Iterator<Pseudo> itr = instructions[instNo].livePseudos.iterator();
                        int j = 0;
                        while (itr.hasNext()){
                           p = (Pseudo)itr.next();
                           lInt = p.lInt;

                           reg = IsR.get(lInt);
                           if (reg != null){
                               // Need to spill before the
                               // instruction.
                               if (reg.callerSave){
                                 Iterator<Inst> itr1;
                                 itr1 = instructions[instNo].pred.iterator();
                                 while (itr1.hasNext()){
                                       
                                   Inst pred = itr1.next();
                                   int predInstNo = (pred).instNo;
//                                   myassert(pred.instType !=
//                                                   iType.jumpInst,
//                                           "Jump and call are neighbors.");

                                   System.out.println(predInstNo+" "+
                                                  p.pseudoNo+" "+
                                                  reg.regNo);
                                       
                                 }
                                   
                               }
                           }
                
                        }
                }
           }

           System.out.println(";");
   }
   void output_f(){
          System.out.println("f:=");
          for (int i=1;i<=nPseudos;++i){
                  Pseudo p = pseudos[i];
                  if (!p.local || p.location == null){
                          System.out.println(p.pseudoNo+" "+"-1");
                          continue;
                  }
                  System.out.println(p.pseudoNo+" "+p.location.locNo);
          }
          System.out.println(";");
   }
   void output_loadPair(){
          System.out.println("loadPair:=\n;");
   }
   void output_storePair(){
          System.out.println("storePair:=\n;");
   }
   void output_invLoad(){
          System.out.println("inverseLoad:=\n;");
   }
   void output_invStore(){
          System.out.println("inverseStore:=\n;");
   }
   void output_freeRegs(){
          System.out.println("freeRegs:=\n;");
   }
   void output_moveInsts(){
          System.out.println("RegMoves:=\n;");
   }
   void output_negInsts(){
          System.out.println("negInsts:=\n;");
   }
   void output_andInsts(){
          System.out.println("andInsts:=\n;");
   }
   void output_orInsts(){
          System.out.println("orInsts:=\n;");
   }
   void output_xorInsts(){
          System.out.println("xorInsts:=\n;");
   }
   void output(){
           output_xdef();
           output_psr();
           output_spLoad();
           output_loadPair();
           output_spStore();
           output_storePair();
           output_f();
           output_invLoad();
           output_invStore();
           output_freeRegs();
           output_moveInsts();
   }
   public void doLinearScan(){
           makeLinearIntervals();
           linearScanRegisterAllocation();
           output();
   }

   /**
    * f0 -> pseudoSet()
    * f1 -> locSet()
    * f2 -> instSet()
    * f3 -> regSet()
    */
   public R visit(setCollection n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> callerSaveParam()
    * f1 -> freqParam()
    * f2 -> liveParam()
    * f3 -> liveHardRegParam()
    * f4 -> basePseudoRegParam()
    * f5 -> baseHardRegParam()
    * f6 -> reqParam()
    * f7 -> HRreqParam()
    * f8 -> prevInstParam()
    * f9 -> prevInstsParam()
    * f10 -> defParam()
    * f11 -> defHardRegParam()
    * f12 -> lsmPseudosParam()
    * f13 -> memPseudosParam()
    * f14 -> nsEdgeParam()
    * f15 -> equivParam()
    * f16 -> knownStoresParam()
    * f17 -> knownHardStoresParam()
    * f18 -> knownLoadsParam()
    * f19 -> jumpInstParam()
    * f20 -> callInstParam()
    * f21 -> scalarParams()
    */
   public R visit(paramCollection n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
      n.f11.accept(this, argu);
      n.f12.accept(this, argu);
      n.f13.accept(this, argu);
      n.f14.accept(this, argu);
      n.f15.accept(this, argu);
      n.f16.accept(this, argu);
      n.f17.accept(this, argu);
      n.f18.accept(this, argu);
      n.f19.accept(this, argu);
      n.f20.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <SET>
    * f1 -> <PSEUDOS>
    * f2 -> <ASSIGN>
    * f3 -> ( pseudo() )*
    * f4 -> <SEMICOLON>
    */
   public R visit(pseudoSet n, A argu) {
      R _ret=null;
      build_sets = true;
      n.f3.accept(this, argu);
      build_sets = false;
      return _ret;
   }

   /**
    * f0 -> <SET>
    * f1 -> <REGS>
    * f2 -> <ASSIGN>
    * f3 -> ( register() )*
    * f4 -> <SEMICOLON>
    */
   public R visit(regSet n, A argu) {
      R _ret=null;
      build_sets = true;
      n.f3.accept(this, argu);
      build_sets = false;
      return _ret;
   }

   /**
    * f0 -> <SET>
    * f1 -> <LOC>
    * f2 -> <ASSIGN>
    * f3 -> ( location() )*
    * f4 -> <SEMICOLON>
    */
   public R visit(locSet n, A argu) {
      R _ret=null;
      build_sets = true;
      n.f3.accept(this, argu);
      build_sets = false;
      return _ret;
   }

   /**
    * f0 -> <SET>
    * f1 -> <INSTS>
    * f2 -> <ASSIGN>
    * f3 -> ( instruction() )*
    * f4 -> <SEMICOLON>
    */
   public R visit(instSet n, A argu) {
      R _ret=null;
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> ( <COLON> )?
    * f2 -> <CALLERSAVE>
    * f3 -> <ASSIGN>
    * f4 -> ( callerSaveInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(callerSaveParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <FREQ>
    * f3 -> <ASSIGN>
    * f4 -> ( freqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(freqParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LIVE>
    * f3 -> <ASSIGN>
    * f4 -> ( liveInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(liveParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LIVEHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( liveHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(liveHardRegParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <BASEPSEUDOREG>
    * f3 -> <ASSIGN>
    * f4 -> ( basePseudoRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(basePseudoRegParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <BASEHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( baseHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(baseHardRegParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <REQ>
    * f3 -> <ASSIGN>
    * f4 -> ( reqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(reqParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <HRREQ>
    * f3 -> <ASSIGN>
    * f4 -> ( HRreqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(HRreqParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <PREVINST>
    * f3 -> <ASSIGN>
    * f4 -> ( prevInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(prevInstParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <PREVINSTS>
    * f3 -> <ASSIGN>
    * f4 -> ( prevInstsInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(prevInstsParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <DEF>
    * f3 -> <ASSIGN>
    * f4 -> ( defInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(defParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <DEFHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( defHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(defHardRegParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LSMPSEUDOS>
    * f3 -> <ASSIGN>
    * f4 -> ( lsmPseudoInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(lsmPseudosParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <MEMPSEUDOS>
    * f3 -> <ASSIGN>
    * f4 -> ( memPseudoInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(memPseudosParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <NSEDGE>
    * f3 -> <ASSIGN>
    * f4 -> ( nsEdgeInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(nsEdgeParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <EQUIV>
    * f3 -> <ASSIGN>
    * f4 -> ( equivInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(equivParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNSTORES>
    * f3 -> <ASSIGN>
    * f4 -> ( knownStoreInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(knownStoresParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNHARDSTORES>
    * f3 -> <ASSIGN>
    * f4 -> ( knownHardStoreInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(knownHardStoresParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNLOADS>
    * f3 -> <ASSIGN>
    * f4 -> ( knownLoadInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(knownLoadsParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <JUMPINST>
    * f3 -> <ASSIGN>
    * f4 -> ( jumpInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(jumpInstParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <CALLINST>
    * f3 -> <ASSIGN>
    * f4 -> ( callInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(callInstParam n, A argu) {
      R _ret=null;
      n.f4.accept(this, argu);
      return _ret;
   }
   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <MOVEINST>
    * f3 -> <ASSIGN>
    * f4 -> ( moveInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(moveInstParam n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }


   /**
    * f0 -> <PARAM>
    * f1 -> <LOADCOST>
    * f2 -> <ASSIGN>
    * f3 -> value()
    * f4 -> <SEMICOLON>
    * f5 -> <PARAM>
    * f6 -> <LOADPAIRCOST>
    * f7 -> <ASSIGN>
    * f8 -> value()
    * f9 -> <SEMICOLON>
    * f10 -> <PARAM>
    * f11 -> <INVLOADCOST>
    * f12 -> <ASSIGN>
    * f13 -> value()
    * f14 -> <SEMICOLON>
    * f15 -> <PARAM>
    * f16 -> <STORECOST>
    * f17 -> <ASSIGN>
    * f18 -> value()
    * f19 -> <SEMICOLON>
    * f20 -> <PARAM>
    * f21 -> <STOREPAIRCOST>
    * f22 -> <ASSIGN>
    * f23 -> value()
    * f24 -> <SEMICOLON>
    * f25 -> <PARAM>
    * f26 -> <INVSTORECOST>
    * f27 -> <ASSIGN>
    * f28 -> value()
    * f29 -> <SEMICOLON>
    * f30 -> <PARAM>
    * f31 -> <NREGS>
    * f32 -> <ASSIGN>
    * f33 -> value()
    * f34 -> <SEMICOLON>
    * f35 -> <PARAM>
    * f36 -> <NINSTS>
    * f37 -> <ASSIGN>
    * f38 -> value()
    * f39 -> <SEMICOLON>
    * f40 -> <PARAM>
    * f41 -> <NLSMPSEUDOS>
    * f42 -> <ASSIGN>
    * f43 -> value()
    * f44 -> <SEMICOLON>
    * f45 -> <PARAM>
    * f46 -> <NPSEUDOS>
    * f47 -> <ASSIGN>
    * f48 -> value()
    * f49 -> <SEMICOLON>
    */
   public R visit(scalarParams n, A argu) {
      R _ret=null;

      nRegs = intTokenToInt(n.f33.f0);
      nInsts = intTokenToInt(n.f38.f0);
      nLSMPseudos = intTokenToInt(n.f43.f0);
      nPseudos = intTokenToInt(n.f48.f0);

      return _ret;
   }

   /**
    * f0 -> register()
    * f1 -> value()
    */
   public R visit(callerSaveInfo n, A argu) {
      R _ret=null;
      int rNo = intTokenToInt(n.f0.f0);
      registers[rNo].callerSave = 
        intTokenToInt(n.f1.f0) == 1;
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public R visit(callInstInfo n, A argu) {
      R _ret=null;
      int iNo = intTokenToInt(n.f0.f0);
      if (intTokenToInt(n.f1.f0) == 1)
              instructions[iNo].instType = iType.callInst;
      return _ret;
   }
   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public R visit(moveInstInfo n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }



   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public R visit(jumpInstInfo n, A argu) {
      R _ret=null;

      int iNo = intTokenToInt(n.f0.f0);
      if (intTokenToInt(n.f1.f0) == 1)
              instructions[iNo].instType = iType.jumpInst;

      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public R visit(freqInfo n, A argu) {
      R _ret=null;

      int iNo = intTokenToInt(n.f0.f0);
      int freq = intTokenToInt(n.f1.f0);

      instructions[iNo] = new Inst();
      instructions[iNo].freq = freq;
      instructions[iNo].instNo = iNo;
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(liveInfo n, A argu) {
      R _ret=null;
      int iNo = intTokenToInt(n.f0.f0);
      int pNo = intTokenToInt(n.f1.f0);
      int val = intTokenToInt(n.f2.f0);
      if (val == 1){
              instructions[iNo].livePseudos.add(pseudos[pNo]);
      }
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(reqInfo n, A argu) {
      R _ret=null;
      int iNo = intTokenToInt(n.f0.f0);
      int pNo = intTokenToInt(n.f1.f0);
      int val = intTokenToInt(n.f2.f0);
      if (val == 1){
              instructions[iNo].req.add(pseudos[pNo]);
      }

      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(defInfo n, A argu) {
      R _ret=null;
      int iNo = intTokenToInt(n.f0.f0);
      int pNo = intTokenToInt(n.f1.f0);
      int val = intTokenToInt(n.f2.f0);
      if (val == 1){
              instructions[iNo].def = pseudos[pNo];
      }
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(knownLoadInfo n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public R visit(liveHardRegInfo n, A argu) {
      R _ret=null;
      int iNo = intTokenToInt(n.f0.f0);
      int rNo = intTokenToInt(n.f1.f0);
      int val = intTokenToInt(n.f2.f0);
      if (val == 1){
              instructions[iNo].liveRegs.add(registers[rNo]);
              registers[rNo].precolored = true;
      }
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public R visit(defHardRegInfo n, A argu) {
      R _ret=null;
      int iNo = intTokenToInt(n.f0.f0);
      int rNo = intTokenToInt(n.f1.f0);
      int val = intTokenToInt(n.f2.f0);
      if (val == 1){
              instructions[iNo].defHardReg = registers[rNo];
      }
       return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public R visit(HRreqInfo n, A argu) {
      R _ret=null;
      int iNo = intTokenToInt(n.f0.f0);
      int rNo = intTokenToInt(n.f1.f0);
      int val = intTokenToInt(n.f2.f0);
      if (val == 1){
              instructions[iNo].HRreq.add(registers[rNo]);
      }
 
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    */
   public R visit(basePseudoRegInfo n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    */
   public R visit(equivInfo n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> register()
    */
   public R visit(baseHardRegInfo n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> instruction()
    * f2 -> value()
    */
   public R visit(prevInstInfo n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      int iprevNo = intTokenToInt(n.f0.f0);
      int iNo = intTokenToInt(n.f1.f0);
      int val = intTokenToInt(n.f2.f0);
      if (val == 1){
              instructions[iNo].pred.add(instructions[iprevNo]);
      }
 
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> instruction()
    * f2 -> value()
    */
   public R visit(prevInstsInfo n, A argu) {
      R _ret=null;
      int iprevNo = intTokenToInt(n.f0.f0);
      int iNo = intTokenToInt(n.f1.f0);
      int val = intTokenToInt(n.f2.f0);
      if (val == 1){
              instructions[iNo].pred.add(instructions[iprevNo]);
      }
 
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> value()
    */
   public R visit(lsmPseudoInfo n, A argu) {
      R _ret=null;
      int pNo = intTokenToInt(n.f0.f0);
      int val = intTokenToInt(n.f1.f0);
      if (val == 1){
              pseudos[pNo].local = true;
      }
 
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> value()
    */
   public R visit(memPseudoInfo n, A argu) {
      R _ret=null;

      int pNo = intTokenToInt(n.f0.f0);
      int val = intTokenToInt(n.f1.f0);
      if (val == 1){
              pseudos[pNo].local = false;
      }
 
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(nsEdgeInfo n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> pseudo()
    * f3 -> value()
    */
   public R visit(knownStoreInfo n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> pseudo()
    * f3 -> value()
    */
   public R visit(knownHardStoreInfo n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(value n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(instruction n, A argu) {
      R _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(pseudo n, A argu) {
      R _ret=null;

      if (!build_sets)
              return _ret;

      int pNo = strToInt(n.f0.toString());

      assert(pseudos[pNo] == null);

      pseudos[pNo] = new Pseudo();
      pseudos[pNo].pseudoNo = pNo;

      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(register n, A argu) {
      R _ret=null;

      if (!build_sets)
              return _ret;

      int rNo = strToInt(n.f0.toString());
      assert(registers[rNo] == null);
      registers[rNo] = new Reg();

      registers[rNo].regNo = rNo;
      freeRegs[rNo] = true;
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(location n, A argu) {
      R _ret=null;
      if (!build_sets)
              return _ret;
      int lNo = strToInt(n.f0.toString());

      assert(locations[lNo] == null);

      locations[lNo] = new Loc();
      locations[lNo].locNo = lNo;
      return _ret;
   }

};
