//
// Generated by JTB 1.3.2
//

package visitor;
import syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class GJNoArguDepthFirst<R> implements GJNoArguVisitor<R> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public R visit(NodeList n) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeListOptional n) {
      if ( n.present() ) {
         R _ret=null;
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this);
            _count++;
         }
         return _ret;
      }
      else
         return null;
   }

   public R visit(NodeOptional n) {
      if ( n.present() )
         return n.node.accept(this);
      else
         return null;
   }

   public R visit(NodeSequence n) {
      R _ret=null;
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this);
         _count++;
      }
      return _ret;
   }

   public R visit(NodeToken n) { return null; }

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> scalarParams()
    * f1 -> setCollection()
    * f2 -> paramCollection()
    * f3 -> <EOF>
    */
   public R visit(Goal n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      return _ret;
   }

   /**
    * f0 -> pseudoSet()
    * f1 -> locSet()
    * f2 -> instSet()
    * f3 -> regSet()
    */
   public R visit(setCollection n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      return _ret;
   }

   /**
    * f0 -> callerSaveParam()
    * f1 -> freqParam()
    * f2 -> liveParam()
    * f3 -> liveHardRegParam()
    * f4 -> basePseudoRegParam()
    * f5 -> baseHardRegParam()
    * f6 -> reqParam()
    * f7 -> HRreqParam()
    * f8 -> prevInstParam()
    * f9 -> prevInstsParam()
    * f10 -> defParam()
    * f11 -> defHardRegParam()
    * f12 -> lsmPseudosParam()
    * f13 -> memPseudosParam()
    * f14 -> nsEdgeParam()
    * f15 -> equivParam()
    * f16 -> knownStoresParam()
    * f17 -> knownHardStoresParam()
    * f18 -> knownLoadsParam()
    * f19 -> jumpInstParam()
    * f20 -> callInstParam()
    * f21 -> moveInstParam()
    */
   public R visit(paramCollection n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      n.f6.accept(this);
      n.f7.accept(this);
      n.f8.accept(this);
      n.f9.accept(this);
      n.f10.accept(this);
      n.f11.accept(this);
      n.f12.accept(this);
      n.f13.accept(this);
      n.f14.accept(this);
      n.f15.accept(this);
      n.f16.accept(this);
      n.f17.accept(this);
      n.f18.accept(this);
      n.f19.accept(this);
      n.f20.accept(this);
      n.f21.accept(this);
      return _ret;
   }

   /**
    * f0 -> <SET>
    * f1 -> <PSEUDOS>
    * f2 -> <ASSIGN>
    * f3 -> ( pseudo() )*
    * f4 -> <SEMICOLON>
    */
   public R visit(pseudoSet n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      return _ret;
   }

   /**
    * f0 -> <SET>
    * f1 -> <REGS>
    * f2 -> <ASSIGN>
    * f3 -> ( register() )*
    * f4 -> <SEMICOLON>
    */
   public R visit(regSet n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      return _ret;
   }

   /**
    * f0 -> <SET>
    * f1 -> <LOC>
    * f2 -> <ASSIGN>
    * f3 -> ( location() )*
    * f4 -> <SEMICOLON>
    */
   public R visit(locSet n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      return _ret;
   }

   /**
    * f0 -> <SET>
    * f1 -> <INSTS>
    * f2 -> <ASSIGN>
    * f3 -> ( instruction() )*
    * f4 -> <SEMICOLON>
    */
   public R visit(instSet n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> ( <COLON> )?
    * f2 -> <CALLERSAVE>
    * f3 -> <ASSIGN>
    * f4 -> ( callerSaveInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(callerSaveParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <FREQ>
    * f3 -> <ASSIGN>
    * f4 -> ( freqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(freqParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LIVE>
    * f3 -> <ASSIGN>
    * f4 -> ( liveInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(liveParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LIVEHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( liveHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(liveHardRegParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <BASEPSEUDOREG>
    * f3 -> <ASSIGN>
    * f4 -> ( basePseudoRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(basePseudoRegParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <BASEHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( baseHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(baseHardRegParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <REQ>
    * f3 -> <ASSIGN>
    * f4 -> ( reqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(reqParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <HRREQ>
    * f3 -> <ASSIGN>
    * f4 -> ( HRreqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(HRreqParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <PREVINST>
    * f3 -> <ASSIGN>
    * f4 -> ( prevInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(prevInstParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <PREVINSTS>
    * f3 -> <ASSIGN>
    * f4 -> ( prevInstsInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(prevInstsParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <DEF>
    * f3 -> <ASSIGN>
    * f4 -> ( defInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(defParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <DEFHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( defHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(defHardRegParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LSMPSEUDOS>
    * f3 -> <ASSIGN>
    * f4 -> ( lsmPseudoInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(lsmPseudosParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <MEMPSEUDOS>
    * f3 -> <ASSIGN>
    * f4 -> ( memPseudoInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(memPseudosParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <NSEDGE>
    * f3 -> <ASSIGN>
    * f4 -> ( nsEdgeInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(nsEdgeParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <EQUIV>
    * f3 -> <ASSIGN>
    * f4 -> ( equivInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(equivParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNSTORES>
    * f3 -> <ASSIGN>
    * f4 -> ( knownStoreInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(knownStoresParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNHARDSTORES>
    * f3 -> <ASSIGN>
    * f4 -> ( knownHardStoreInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(knownHardStoresParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNLOADS>
    * f3 -> <ASSIGN>
    * f4 -> ( knownLoadInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(knownLoadsParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <JUMPINST>
    * f3 -> <ASSIGN>
    * f4 -> ( jumpInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(jumpInstParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <CALLINST>
    * f3 -> <ASSIGN>
    * f4 -> ( callInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(callInstParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <MOVEINST>
    * f3 -> <ASSIGN>
    * f4 -> ( moveInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public R visit(moveInstParam n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      return _ret;
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <LOADCOST>
    * f2 -> <ASSIGN>
    * f3 -> value()
    * f4 -> <SEMICOLON>
    * f5 -> <PARAM>
    * f6 -> <LOADPAIRCOST>
    * f7 -> <ASSIGN>
    * f8 -> value()
    * f9 -> <SEMICOLON>
    * f10 -> <PARAM>
    * f11 -> <INVLOADCOST>
    * f12 -> <ASSIGN>
    * f13 -> value()
    * f14 -> <SEMICOLON>
    * f15 -> <PARAM>
    * f16 -> <STORECOST>
    * f17 -> <ASSIGN>
    * f18 -> value()
    * f19 -> <SEMICOLON>
    * f20 -> <PARAM>
    * f21 -> <STOREPAIRCOST>
    * f22 -> <ASSIGN>
    * f23 -> value()
    * f24 -> <SEMICOLON>
    * f25 -> <PARAM>
    * f26 -> <INVSTORECOST>
    * f27 -> <ASSIGN>
    * f28 -> value()
    * f29 -> <SEMICOLON>
    * f30 -> <PARAM>
    * f31 -> <NREGS>
    * f32 -> <ASSIGN>
    * f33 -> value()
    * f34 -> <SEMICOLON>
    * f35 -> <PARAM>
    * f36 -> <NINSTS>
    * f37 -> <ASSIGN>
    * f38 -> value()
    * f39 -> <SEMICOLON>
    * f40 -> <PARAM>
    * f41 -> <NLSMPSEUDOS>
    * f42 -> <ASSIGN>
    * f43 -> value()
    * f44 -> <SEMICOLON>
    * f45 -> <PARAM>
    * f46 -> <NPSEUDOS>
    * f47 -> <ASSIGN>
    * f48 -> value()
    * f49 -> <SEMICOLON>
    * f50 -> <PARAM>
    * f51 -> <NMOVES>
    * f52 -> <ASSIGN>
    * f53 -> value()
    * f54 -> <SEMICOLON>
    */
   public R visit(scalarParams n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
      n.f6.accept(this);
      n.f7.accept(this);
      n.f8.accept(this);
      n.f9.accept(this);
      n.f10.accept(this);
      n.f11.accept(this);
      n.f12.accept(this);
      n.f13.accept(this);
      n.f14.accept(this);
      n.f15.accept(this);
      n.f16.accept(this);
      n.f17.accept(this);
      n.f18.accept(this);
      n.f19.accept(this);
      n.f20.accept(this);
      n.f21.accept(this);
      n.f22.accept(this);
      n.f23.accept(this);
      n.f24.accept(this);
      n.f25.accept(this);
      n.f26.accept(this);
      n.f27.accept(this);
      n.f28.accept(this);
      n.f29.accept(this);
      n.f30.accept(this);
      n.f31.accept(this);
      n.f32.accept(this);
      n.f33.accept(this);
      n.f34.accept(this);
      n.f35.accept(this);
      n.f36.accept(this);
      n.f37.accept(this);
      n.f38.accept(this);
      n.f39.accept(this);
      n.f40.accept(this);
      n.f41.accept(this);
      n.f42.accept(this);
      n.f43.accept(this);
      n.f44.accept(this);
      n.f45.accept(this);
      n.f46.accept(this);
      n.f47.accept(this);
      n.f48.accept(this);
      n.f49.accept(this);
      n.f50.accept(this);
      n.f51.accept(this);
      n.f52.accept(this);
      n.f53.accept(this);
      n.f54.accept(this);
      return _ret;
   }

   /**
    * f0 -> register()
    * f1 -> value()
    */
   public R visit(callerSaveInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public R visit(callInstInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public R visit(moveInstInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public R visit(jumpInstInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public R visit(freqInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(liveInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(reqInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(defInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(knownLoadInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public R visit(liveHardRegInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public R visit(defHardRegInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public R visit(HRreqInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    */
   public R visit(basePseudoRegInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    */
   public R visit(equivInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> register()
    */
   public R visit(baseHardRegInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> instruction()
    * f2 -> value()
    */
   public R visit(prevInstInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> instruction()
    * f2 -> value()
    */
   public R visit(prevInstsInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> value()
    */
   public R visit(lsmPseudoInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> value()
    */
   public R visit(memPseudoInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      return _ret;
   }

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public R visit(nsEdgeInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> pseudo()
    * f3 -> value()
    */
   public R visit(knownStoreInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      return _ret;
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> pseudo()
    * f3 -> value()
    */
   public R visit(knownHardStoreInfo n) {
      R _ret=null;
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(value n) {
      R _ret=null;
      n.f0.accept(this);
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(instruction n) {
      R _ret=null;
      n.f0.accept(this);
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(pseudo n) {
      R _ret=null;
      n.f0.accept(this);
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(register n) {
      R _ret=null;
      n.f0.accept(this);
      return _ret;
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public R visit(location n) {
      R _ret=null;
      n.f0.accept(this);
      return _ret;
   }

}
