//
// Generated by JTB 1.3.2
//

package visitor;
import syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class GJVoidDepthFirst<A> implements GJVoidVisitor<A> {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public void visit(NodeList n, A argu) {
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
   }

   public void visit(NodeListOptional n, A argu) {
      if ( n.present() ) {
         int _count=0;
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
            e.nextElement().accept(this,argu);
            _count++;
         }
      }
   }

   public void visit(NodeOptional n, A argu) {
      if ( n.present() )
         n.node.accept(this,argu);
   }

   public void visit(NodeSequence n, A argu) {
      int _count=0;
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); ) {
         e.nextElement().accept(this,argu);
         _count++;
      }
   }

   public void visit(NodeToken n, A argu) {}

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> scalarParams()
    * f1 -> setCollection()
    * f2 -> paramCollection()
    * f3 -> <EOF>
    */
   public void visit(Goal n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * f0 -> pseudoSet()
    * f1 -> locSet()
    * f2 -> instSet()
    * f3 -> regSet()
    */
   public void visit(setCollection n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * f0 -> callerSaveParam()
    * f1 -> freqParam()
    * f2 -> liveParam()
    * f3 -> liveHardRegParam()
    * f4 -> basePseudoRegParam()
    * f5 -> baseHardRegParam()
    * f6 -> reqParam()
    * f7 -> HRreqParam()
    * f8 -> prevInstParam()
    * f9 -> prevInstsParam()
    * f10 -> defParam()
    * f11 -> defHardRegParam()
    * f12 -> lsmPseudosParam()
    * f13 -> memPseudosParam()
    * f14 -> nsEdgeParam()
    * f15 -> equivParam()
    * f16 -> knownStoresParam()
    * f17 -> knownHardStoresParam()
    * f18 -> knownLoadsParam()
    * f19 -> jumpInstParam()
    * f20 -> callInstParam()
    * f21 -> moveInstParam()
    */
   public void visit(paramCollection n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
      n.f11.accept(this, argu);
      n.f12.accept(this, argu);
      n.f13.accept(this, argu);
      n.f14.accept(this, argu);
      n.f15.accept(this, argu);
      n.f16.accept(this, argu);
      n.f17.accept(this, argu);
      n.f18.accept(this, argu);
      n.f19.accept(this, argu);
      n.f20.accept(this, argu);
      n.f21.accept(this, argu);
   }

   /**
    * f0 -> <SET>
    * f1 -> <PSEUDOS>
    * f2 -> <ASSIGN>
    * f3 -> ( pseudo() )*
    * f4 -> <SEMICOLON>
    */
   public void visit(pseudoSet n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * f0 -> <SET>
    * f1 -> <REGS>
    * f2 -> <ASSIGN>
    * f3 -> ( register() )*
    * f4 -> <SEMICOLON>
    */
   public void visit(regSet n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * f0 -> <SET>
    * f1 -> <LOC>
    * f2 -> <ASSIGN>
    * f3 -> ( location() )*
    * f4 -> <SEMICOLON>
    */
   public void visit(locSet n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * f0 -> <SET>
    * f1 -> <INSTS>
    * f2 -> <ASSIGN>
    * f3 -> ( instruction() )*
    * f4 -> <SEMICOLON>
    */
   public void visit(instSet n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> ( <COLON> )?
    * f2 -> <CALLERSAVE>
    * f3 -> <ASSIGN>
    * f4 -> ( callerSaveInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(callerSaveParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <FREQ>
    * f3 -> <ASSIGN>
    * f4 -> ( freqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(freqParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LIVE>
    * f3 -> <ASSIGN>
    * f4 -> ( liveInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(liveParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LIVEHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( liveHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(liveHardRegParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <BASEPSEUDOREG>
    * f3 -> <ASSIGN>
    * f4 -> ( basePseudoRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(basePseudoRegParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <BASEHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( baseHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(baseHardRegParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <REQ>
    * f3 -> <ASSIGN>
    * f4 -> ( reqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(reqParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <HRREQ>
    * f3 -> <ASSIGN>
    * f4 -> ( HRreqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(HRreqParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <PREVINST>
    * f3 -> <ASSIGN>
    * f4 -> ( prevInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(prevInstParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <PREVINSTS>
    * f3 -> <ASSIGN>
    * f4 -> ( prevInstsInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(prevInstsParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <DEF>
    * f3 -> <ASSIGN>
    * f4 -> ( defInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(defParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <DEFHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( defHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(defHardRegParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LSMPSEUDOS>
    * f3 -> <ASSIGN>
    * f4 -> ( lsmPseudoInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(lsmPseudosParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <MEMPSEUDOS>
    * f3 -> <ASSIGN>
    * f4 -> ( memPseudoInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(memPseudosParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <NSEDGE>
    * f3 -> <ASSIGN>
    * f4 -> ( nsEdgeInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(nsEdgeParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <EQUIV>
    * f3 -> <ASSIGN>
    * f4 -> ( equivInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(equivParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNSTORES>
    * f3 -> <ASSIGN>
    * f4 -> ( knownStoreInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(knownStoresParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNHARDSTORES>
    * f3 -> <ASSIGN>
    * f4 -> ( knownHardStoreInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(knownHardStoresParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNLOADS>
    * f3 -> <ASSIGN>
    * f4 -> ( knownLoadInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(knownLoadsParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <JUMPINST>
    * f3 -> <ASSIGN>
    * f4 -> ( jumpInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(jumpInstParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <CALLINST>
    * f3 -> <ASSIGN>
    * f4 -> ( callInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(callInstParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <MOVEINST>
    * f3 -> <ASSIGN>
    * f4 -> ( moveInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(moveInstParam n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
   }

   /**
    * f0 -> <PARAM>
    * f1 -> <LOADCOST>
    * f2 -> <ASSIGN>
    * f3 -> value()
    * f4 -> <SEMICOLON>
    * f5 -> <PARAM>
    * f6 -> <LOADPAIRCOST>
    * f7 -> <ASSIGN>
    * f8 -> value()
    * f9 -> <SEMICOLON>
    * f10 -> <PARAM>
    * f11 -> <INVLOADCOST>
    * f12 -> <ASSIGN>
    * f13 -> value()
    * f14 -> <SEMICOLON>
    * f15 -> <PARAM>
    * f16 -> <STORECOST>
    * f17 -> <ASSIGN>
    * f18 -> value()
    * f19 -> <SEMICOLON>
    * f20 -> <PARAM>
    * f21 -> <STOREPAIRCOST>
    * f22 -> <ASSIGN>
    * f23 -> value()
    * f24 -> <SEMICOLON>
    * f25 -> <PARAM>
    * f26 -> <INVSTORECOST>
    * f27 -> <ASSIGN>
    * f28 -> value()
    * f29 -> <SEMICOLON>
    * f30 -> <PARAM>
    * f31 -> <NREGS>
    * f32 -> <ASSIGN>
    * f33 -> value()
    * f34 -> <SEMICOLON>
    * f35 -> <PARAM>
    * f36 -> <NINSTS>
    * f37 -> <ASSIGN>
    * f38 -> value()
    * f39 -> <SEMICOLON>
    * f40 -> <PARAM>
    * f41 -> <NLSMPSEUDOS>
    * f42 -> <ASSIGN>
    * f43 -> value()
    * f44 -> <SEMICOLON>
    * f45 -> <PARAM>
    * f46 -> <NPSEUDOS>
    * f47 -> <ASSIGN>
    * f48 -> value()
    * f49 -> <SEMICOLON>
    * f50 -> <PARAM>
    * f51 -> <NMOVES>
    * f52 -> <ASSIGN>
    * f53 -> value()
    * f54 -> <SEMICOLON>
    */
   public void visit(scalarParams n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      n.f6.accept(this, argu);
      n.f7.accept(this, argu);
      n.f8.accept(this, argu);
      n.f9.accept(this, argu);
      n.f10.accept(this, argu);
      n.f11.accept(this, argu);
      n.f12.accept(this, argu);
      n.f13.accept(this, argu);
      n.f14.accept(this, argu);
      n.f15.accept(this, argu);
      n.f16.accept(this, argu);
      n.f17.accept(this, argu);
      n.f18.accept(this, argu);
      n.f19.accept(this, argu);
      n.f20.accept(this, argu);
      n.f21.accept(this, argu);
      n.f22.accept(this, argu);
      n.f23.accept(this, argu);
      n.f24.accept(this, argu);
      n.f25.accept(this, argu);
      n.f26.accept(this, argu);
      n.f27.accept(this, argu);
      n.f28.accept(this, argu);
      n.f29.accept(this, argu);
      n.f30.accept(this, argu);
      n.f31.accept(this, argu);
      n.f32.accept(this, argu);
      n.f33.accept(this, argu);
      n.f34.accept(this, argu);
      n.f35.accept(this, argu);
      n.f36.accept(this, argu);
      n.f37.accept(this, argu);
      n.f38.accept(this, argu);
      n.f39.accept(this, argu);
      n.f40.accept(this, argu);
      n.f41.accept(this, argu);
      n.f42.accept(this, argu);
      n.f43.accept(this, argu);
      n.f44.accept(this, argu);
      n.f45.accept(this, argu);
      n.f46.accept(this, argu);
      n.f47.accept(this, argu);
      n.f48.accept(this, argu);
      n.f49.accept(this, argu);
      n.f50.accept(this, argu);
      n.f51.accept(this, argu);
      n.f52.accept(this, argu);
      n.f53.accept(this, argu);
      n.f54.accept(this, argu);
   }

   /**
    * f0 -> register()
    * f1 -> value()
    */
   public void visit(callerSaveInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public void visit(callInstInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public void visit(moveInstInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public void visit(jumpInstInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public void visit(freqInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(liveInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(reqInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(defInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(knownLoadInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public void visit(liveHardRegInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public void visit(defHardRegInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public void visit(HRreqInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    */
   public void visit(basePseudoRegInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    */
   public void visit(equivInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> pseudo()
    * f1 -> register()
    */
   public void visit(baseHardRegInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> instruction()
    * f2 -> value()
    */
   public void visit(prevInstInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> instruction()
    * f2 -> value()
    */
   public void visit(prevInstsInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> pseudo()
    * f1 -> value()
    */
   public void visit(lsmPseudoInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> pseudo()
    * f1 -> value()
    */
   public void visit(memPseudoInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
   }

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(nsEdgeInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> pseudo()
    * f3 -> value()
    */
   public void visit(knownStoreInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> pseudo()
    * f3 -> value()
    */
   public void visit(knownHardStoreInfo n, A argu) {
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(value n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(instruction n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(pseudo n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(register n, A argu) {
      n.f0.accept(this, argu);
   }

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(location n, A argu) {
      n.f0.accept(this, argu);
   }

}
