//
// Generated by JTB 1.3.2
//

package visitor;
import syntaxtree.*;
import java.util.*;

/**
 * All void visitors must implement this interface.
 */

public interface Visitor {

   //
   // void Auto class visitors
   //

   public void visit(NodeList n);
   public void visit(NodeListOptional n);
   public void visit(NodeOptional n);
   public void visit(NodeSequence n);
   public void visit(NodeToken n);

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> scalarParams()
    * f1 -> setCollection()
    * f2 -> paramCollection()
    * f3 -> <EOF>
    */
   public void visit(Goal n);

   /**
    * f0 -> pseudoSet()
    * f1 -> locSet()
    * f2 -> instSet()
    * f3 -> regSet()
    */
   public void visit(setCollection n);

   /**
    * f0 -> callerSaveParam()
    * f1 -> freqParam()
    * f2 -> liveParam()
    * f3 -> liveHardRegParam()
    * f4 -> basePseudoRegParam()
    * f5 -> baseHardRegParam()
    * f6 -> reqParam()
    * f7 -> HRreqParam()
    * f8 -> prevInstParam()
    * f9 -> prevInstsParam()
    * f10 -> defParam()
    * f11 -> defHardRegParam()
    * f12 -> lsmPseudosParam()
    * f13 -> memPseudosParam()
    * f14 -> nsEdgeParam()
    * f15 -> equivParam()
    * f16 -> knownStoresParam()
    * f17 -> knownHardStoresParam()
    * f18 -> knownLoadsParam()
    * f19 -> jumpInstParam()
    * f20 -> callInstParam()
    * f21 -> moveInstParam()
    */
   public void visit(paramCollection n);

   /**
    * f0 -> <SET>
    * f1 -> <PSEUDOS>
    * f2 -> <ASSIGN>
    * f3 -> ( pseudo() )*
    * f4 -> <SEMICOLON>
    */
   public void visit(pseudoSet n);

   /**
    * f0 -> <SET>
    * f1 -> <REGS>
    * f2 -> <ASSIGN>
    * f3 -> ( register() )*
    * f4 -> <SEMICOLON>
    */
   public void visit(regSet n);

   /**
    * f0 -> <SET>
    * f1 -> <LOC>
    * f2 -> <ASSIGN>
    * f3 -> ( location() )*
    * f4 -> <SEMICOLON>
    */
   public void visit(locSet n);

   /**
    * f0 -> <SET>
    * f1 -> <INSTS>
    * f2 -> <ASSIGN>
    * f3 -> ( instruction() )*
    * f4 -> <SEMICOLON>
    */
   public void visit(instSet n);

   /**
    * f0 -> <PARAM>
    * f1 -> ( <COLON> )?
    * f2 -> <CALLERSAVE>
    * f3 -> <ASSIGN>
    * f4 -> ( callerSaveInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(callerSaveParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <FREQ>
    * f3 -> <ASSIGN>
    * f4 -> ( freqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(freqParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LIVE>
    * f3 -> <ASSIGN>
    * f4 -> ( liveInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(liveParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LIVEHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( liveHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(liveHardRegParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <BASEPSEUDOREG>
    * f3 -> <ASSIGN>
    * f4 -> ( basePseudoRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(basePseudoRegParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <BASEHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( baseHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(baseHardRegParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <REQ>
    * f3 -> <ASSIGN>
    * f4 -> ( reqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(reqParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <HRREQ>
    * f3 -> <ASSIGN>
    * f4 -> ( HRreqInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(HRreqParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <PREVINST>
    * f3 -> <ASSIGN>
    * f4 -> ( prevInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(prevInstParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <PREVINSTS>
    * f3 -> <ASSIGN>
    * f4 -> ( prevInstsInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(prevInstsParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <DEF>
    * f3 -> <ASSIGN>
    * f4 -> ( defInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(defParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <DEFHARDREG>
    * f3 -> <ASSIGN>
    * f4 -> ( defHardRegInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(defHardRegParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <LSMPSEUDOS>
    * f3 -> <ASSIGN>
    * f4 -> ( lsmPseudoInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(lsmPseudosParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <MEMPSEUDOS>
    * f3 -> <ASSIGN>
    * f4 -> ( memPseudoInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(memPseudosParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <NSEDGE>
    * f3 -> <ASSIGN>
    * f4 -> ( nsEdgeInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(nsEdgeParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <EQUIV>
    * f3 -> <ASSIGN>
    * f4 -> ( equivInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(equivParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNSTORES>
    * f3 -> <ASSIGN>
    * f4 -> ( knownStoreInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(knownStoresParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNHARDSTORES>
    * f3 -> <ASSIGN>
    * f4 -> ( knownHardStoreInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(knownHardStoresParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <KNOWNLOADS>
    * f3 -> <ASSIGN>
    * f4 -> ( knownLoadInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(knownLoadsParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <JUMPINST>
    * f3 -> <ASSIGN>
    * f4 -> ( jumpInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(jumpInstParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <CALLINST>
    * f3 -> <ASSIGN>
    * f4 -> ( callInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(callInstParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <COLON>
    * f2 -> <MOVEINST>
    * f3 -> <ASSIGN>
    * f4 -> ( moveInstInfo() )*
    * f5 -> <SEMICOLON>
    */
   public void visit(moveInstParam n);

   /**
    * f0 -> <PARAM>
    * f1 -> <LOADCOST>
    * f2 -> <ASSIGN>
    * f3 -> value()
    * f4 -> <SEMICOLON>
    * f5 -> <PARAM>
    * f6 -> <LOADPAIRCOST>
    * f7 -> <ASSIGN>
    * f8 -> value()
    * f9 -> <SEMICOLON>
    * f10 -> <PARAM>
    * f11 -> <INVLOADCOST>
    * f12 -> <ASSIGN>
    * f13 -> value()
    * f14 -> <SEMICOLON>
    * f15 -> <PARAM>
    * f16 -> <STORECOST>
    * f17 -> <ASSIGN>
    * f18 -> value()
    * f19 -> <SEMICOLON>
    * f20 -> <PARAM>
    * f21 -> <STOREPAIRCOST>
    * f22 -> <ASSIGN>
    * f23 -> value()
    * f24 -> <SEMICOLON>
    * f25 -> <PARAM>
    * f26 -> <INVSTORECOST>
    * f27 -> <ASSIGN>
    * f28 -> value()
    * f29 -> <SEMICOLON>
    * f30 -> <PARAM>
    * f31 -> <NREGS>
    * f32 -> <ASSIGN>
    * f33 -> value()
    * f34 -> <SEMICOLON>
    * f35 -> <PARAM>
    * f36 -> <NINSTS>
    * f37 -> <ASSIGN>
    * f38 -> value()
    * f39 -> <SEMICOLON>
    * f40 -> <PARAM>
    * f41 -> <NLSMPSEUDOS>
    * f42 -> <ASSIGN>
    * f43 -> value()
    * f44 -> <SEMICOLON>
    * f45 -> <PARAM>
    * f46 -> <NPSEUDOS>
    * f47 -> <ASSIGN>
    * f48 -> value()
    * f49 -> <SEMICOLON>
    * f50 -> <PARAM>
    * f51 -> <NMOVES>
    * f52 -> <ASSIGN>
    * f53 -> value()
    * f54 -> <SEMICOLON>
    */
   public void visit(scalarParams n);

   /**
    * f0 -> register()
    * f1 -> value()
    */
   public void visit(callerSaveInfo n);

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public void visit(callInstInfo n);

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public void visit(moveInstInfo n);

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public void visit(jumpInstInfo n);

   /**
    * f0 -> instruction()
    * f1 -> value()
    */
   public void visit(freqInfo n);

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(liveInfo n);

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(reqInfo n);

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(defInfo n);

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(knownLoadInfo n);

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public void visit(liveHardRegInfo n);

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public void visit(defHardRegInfo n);

   /**
    * f0 -> instruction()
    * f1 -> register()
    * f2 -> value()
    */
   public void visit(HRreqInfo n);

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    */
   public void visit(basePseudoRegInfo n);

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    */
   public void visit(equivInfo n);

   /**
    * f0 -> pseudo()
    * f1 -> register()
    */
   public void visit(baseHardRegInfo n);

   /**
    * f0 -> instruction()
    * f1 -> instruction()
    * f2 -> value()
    */
   public void visit(prevInstInfo n);

   /**
    * f0 -> instruction()
    * f1 -> instruction()
    * f2 -> value()
    */
   public void visit(prevInstsInfo n);

   /**
    * f0 -> pseudo()
    * f1 -> value()
    */
   public void visit(lsmPseudoInfo n);

   /**
    * f0 -> pseudo()
    * f1 -> value()
    */
   public void visit(memPseudoInfo n);

   /**
    * f0 -> pseudo()
    * f1 -> pseudo()
    * f2 -> value()
    */
   public void visit(nsEdgeInfo n);

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> pseudo()
    * f3 -> value()
    */
   public void visit(knownStoreInfo n);

   /**
    * f0 -> instruction()
    * f1 -> pseudo()
    * f2 -> pseudo()
    * f3 -> value()
    */
   public void visit(knownHardStoreInfo n);

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(value n);

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(instruction n);

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(pseudo n);

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(register n);

   /**
    * f0 -> <INTEGER_LITERAL>
    */
   public void visit(location n);

}

